<template>
  <div class="inputPartName">
    <div
      :class="{ '-invalid': classes['-invalid'] }"
      class="input">
      <div
        class="no-checkbox partname"
        :class="{ 'multiselect--active': isOpen }">
        <div
          class="multiselect__select"
          @click="focusInput"/>
        <div class="multiselect__tags" >
          <input
            type="text"
            :value="value.name"
            @input="onPartNameInput"
            @focus="isFocused = true"
            @blur="isFocused = false"
            class="partname input-field"
            placeholder="Название запчасти *">
        </div>
        <div
          v-show="isOpen"
          class="multiselect__content-wrapper">
          <ul class="multiselect__content">
            <template v-if="searchingParts.length">
              <li
                class="multiselect__element"
                v-for="(option, i) of searchingParts"
                :key="i"
                @mousedown="select(option)">
                <span class="multiselect__option">{{ option.name }}</span>
              </li>
            </template>
            <template v-else-if="!!partNameQuery">
              <li class="multiselect__element">
                <span class="multiselect__option">Не найдено </span>
              </li>
            </template>
            <template v-else>
              <li class="multiselect__element">
                <span class="multiselect__option">Начните вводить название запчасти </span>
              </li>
            </template>
          </ul>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { debounce } from 'lodash-es';
import AppSelectComposite from '~/components/redesign/app-select/app-select-composite';

export default {
  name: 'InputPartName',
  components: {
    AppSelectComposite,
  },
  props: {
    classes: {
      type: Object,
      default() { return {}; },
    },
    value: {
      type: Object,
      default() { return { id: null, name: null }; },
    },
  },
  data() {
    return {
      isOpen: false,
      partNameQuery: '',
      searchingParts: [],
      isFocused: false,
    };
  },
  created() {
    this.searchPartsDebounced = debounce(this.searchParts, 200);
  },
  mounted() {
    document.addEventListener('click', (e) => {
      const partname = e.target.closest('.no-checkbox.partname');

      if (!partname || partname !== this.$el) {
        this.isOpen = false;
      }
    });
  },
  methods: {
    focusInput(e) {
      this.isOpen = !this.isOpen;
      const el = e.currentTarget.closest('.no-checkbox.partname').querySelector('input.partname');
      if (this.isOpen) {
        el.focus();
        this.isFocused = true;
      } else {
        el.blur();
      }
    },
    onPartNameInput(e) {
      const newValue = e.target.value;

      if ((!this.partNameQuery.length && !this.searchingParts.length)
          || !(newValue.includes(this.partNameQuery) && !this.searchingParts.length)) {
        this.searchPartsDebounced(newValue);
      }
      this.partNameQuery = newValue;
      this.$emit('input', { id: null, name: newValue });
    },
    searchParts(query) {
      if (query) {
        this.$axios.$get('/_main/partItemName/get', { params: { searchString: query } })
          .then(({ data }) => {
            this.searchingParts = data;
            this.isOpen = true;
          })
          .catch(e => console.log(e));
      } else {
        this.searchingParts = [];
      }
    },
    select(option) {
      this.$emit('input', { ...option });
      this.isOpen = false;
    },
  },
};

</script>
<style lang="postcss">
.inputPartName {
  position: relative;
  .multiselect__input.partname {
    width: 100% !important;
  }

  .multiselect__option:hover {
    background: #dee7ed;
  }

  & .-disabled {
    .multiselect {
      background-color: var(--bg-lightest);

      &.input-field.multiselect--selected {
        background-color: var(--bg-lightest);
      }
    }
  }

  .multiselect__tags,
  .multiselect__input {
    border: none !important;
    background-color: #fff !important;
    box-shadow: none !important;
    outline: none;
    padding: 0;
    margin: 0;
  }
  .multiselect.multiselect--selected .multiselect__tags:after {
    display: none;
  }
  .multiselect.input-field.multiselect--selected {
    background-color: #fff;
  }
  .multiselect.input-field.multiselect--active {
    box-shadow: inset 0 0 0 1px var(--form-focus-border-color);
  }
  .multiselect__content-wrapper {
    right: 0;
  }
  .inputComposite {
    position: static;
    &-label {
      z-index: 2;
    }
  }
}
</style>
